package com.ecep.contract.ds.other.controller;

import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.ecep.contract.ds.other.service.BankService;
import com.ecep.contract.model.Bank;

@RestController
@RequestMapping("/bank")
public class BankController {
    @Autowired
    private BankService bankService;

    @RequestMapping("/findById")
    public Bank findById(Integer id) {
        return bankService.findById(id);
    }

    @RequestMapping("/list")
    public Page<Bank> list(
            Map<String, Object> params,
            @RequestParam(defaultValue = "0", name = "page") int pageNumber,
            @RequestParam(defaultValue = "10", name = "size") int pageSize) {
        Specification<Bank> spec = null;
        Sort sort = Sort.by(Sort.Order.desc("id"));
        Pageable pageable = PageRequest.of(pageNumber, pageSize, sort);
        // PagedModel<Bank> pagedModel = new PagedModel<>();
        return bankService.findAll(spec, pageable);
    }

    @RequestMapping("/save")
    public Bank save(Bank bank) {
        return bankService.save(bank);
    }

    @RequestMapping("/delete")
    public void delete(Integer id) {
        Bank bank = bankService.findById(id);
        bankService.delete(bank);
    }
}
